## mathgl 8.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

if(POLICY CMP0078)
    cmake_policy(SET CMP0078 NEW)
endif()
if(POLICY CMP0086)
    cmake_policy(SET CMP0086 NEW)
endif()
if(POLICY CMP0127)
    cmake_policy(SET CMP0127 NEW)
endif()

project( MathGL2 )

set(mgl_clean_files )
set(MGL_DEP_LIBS)
add_definitions(-DMGL_SRC)

#add_definitions(-DZLIB_WINAPI)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${MathGL2_SOURCE_DIR}/scripts)

if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are:
		None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif(NOT CMAKE_BUILD_TYPE)

set(CMAKE_VERBOSE_MAKEFILE ON)
set(MathGL_VERSION_MAJOR 8)
set(MathGL_VERSION_MINOR 0)
set(MathGL_PATCH_VERSION 1)
set(MathGL_VERSION ${MathGL_VERSION_MAJOR}.${MathGL_VERSION_MINOR}.${MathGL_PATCH_VERSION})
set(MathGL_SOVERSION ${MathGL_VERSION_MAJOR})
string(TIMESTAMP MathGL_DATE UTC)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
	option(enable-lcov "Enable coverage." OFF)
	if(enable-lcov)
		include(CodeCoverage)
		APPEND_COVERAGE_COMPILER_FLAGS()
	endif(enable-lcov)
else(CMAKE_BUILD_TYPE STREQUAL "Debug")
	unset(enable-lcov CACHE)
endif(CMAKE_BUILD_TYPE STREQUAL "Debug")

#set(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE 1)
set(MathGL_INSTALL_LIB_DIR "lib" CACHE PATH "Installation directory for libraries")
set(MathGL_INSTALL_BIN_DIR "bin" CACHE PATH "Installation directory for executables")
set(MathGL_INSTALL_INCLUDE_DIR "include" CACHE PATH "Installation directory for headers")
if(WIN32 AND NOT CYGWIN)
	set(DEF_INSTALL_CMAKE_DIR cmake)
else()
	set(DEF_INSTALL_CMAKE_DIR lib/cmake/mathgl2)
endif()
set(MathGL_INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH "Installation directory for CMake files")
# Make relative paths absolute (needed later on)
foreach(p LIB BIN INCLUDE CMAKE)
	set(var MathGL_INSTALL_${p}_DIR)
	if(NOT IS_ABSOLUTE "${${var}}")
		set(${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
	endif()
endforeach()

macro(mgl_po_src)
	set(l_files )
	foreach(src_file ${ARGN})
		get_filename_component(fp ${src_file} ABSOLUTE)
		file(RELATIVE_PATH rel ${CMAKE_SOURCE_DIR} ${fp})
		list(APPEND l_files "${rel}")
	endforeach(src_file ${ARGN})
	set(po_files ${po_files} ${l_files} PARENT_SCOPE)
endmacro(mgl_po_src)

function(mgl_add_lib mgl_tmp_lib)
	if(${mgl_tmp_lib} MATCHES mgl)
		set(mgllib mgl)
		set(mgllib2 mgl2)
	else(${mgl_tmp_lib} MATCHES mgl)
		set(mgllib mgl-${mgl_tmp_lib})
		set(mgllib2 mgl2-${mgl_tmp_lib})
	endif(${mgl_tmp_lib} MATCHES mgl)
	set(mgl_src_lst ${ARGV})
	list(REMOVE_AT mgl_src_lst 0)
	add_library(${mgllib} SHARED ${mgl_src_lst})
	add_library(${mgllib}-static STATIC ${mgl_src_lst})
	set_target_properties(${mgllib} PROPERTIES SOVERSION ${MathGL_SOVERSION})
	set_target_properties(${mgllib} PROPERTIES VERSION ${MathGL_VERSION})
	set_target_properties(${mgllib} PROPERTIES DEFINE_SYMBOL "mgl_EXPORTS")
	set_target_properties(${mgllib} PROPERTIES C_VISIBILITY_PRESET hidden)
	set_target_properties(${mgllib} PROPERTIES CXX_VISIBILITY_PRESET hidden)
	set_target_properties(${mgllib} PROPERTIES VISIBILITY_INLINES_HIDDEN 1)
	target_compile_definitions(${mgllib}-static PUBLIC MGL_STATIC_DEFINE)
	if(MSVC)
		set(mgl_lib_static "-static")
		set (CMAKE_DEBUG_POSTFIX "d")
		set_target_properties(${mgllib} PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX})
		set_target_properties(${mgllib}-static PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX})
#		if(CMAKE_BUILD_TYPE STREQUAL "Debug")
#			set(mgl_lib_end "d")
#		else(CMAKE_BUILD_TYPE STREQUAL "Debug")
#			set(mgl_lib_end)
#		endif(CMAKE_BUILD_TYPE STREQUAL "Debug")
	elseif(MSVC)
		set(mgl_lib_static)
		set_target_properties(${mgllib} PROPERTIES CLEAN_DIRECT_OUTPUT 1)
	set_target_properties(${mgllib}-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
	endif(MSVC)
	if(enable-mgl2)
			set_target_properties(${mgllib} PROPERTIES OUTPUT_NAME "${mgllib2}${mgl_lib_end}")
			set_target_properties(${mgllib}-static PROPERTIES OUTPUT_NAME "${mgllib2}${mgl_lib_static}${mgl_lib_end}")
	else(enable-mgl2)
			set_target_properties(${mgllib} PROPERTIES OUTPUT_NAME "${mgllib}${mgl_lib_end}")
			set_target_properties(${mgllib}-static PROPERTIES OUTPUT_NAME "${mgllib}${mgl_lib_static}${mgl_lib_end}")
	endif(enable-mgl2)

	install(
			TARGETS ${mgllib} ${mgllib}-static
			EXPORT MathGLTargets
			RUNTIME DESTINATION ${MathGL_INSTALL_BIN_DIR}
			ARCHIVE DESTINATION ${MathGL_INSTALL_LIB_DIR}
			LIBRARY DESTINATION ${MathGL_INSTALL_LIB_DIR}
	)
endfunction(mgl_add_lib mgl_tmp_lib)

MACRO(MGL_DEPENDENT_OPTION option doc default depends1 force1 depends2 force2)
  IF(${option}_ISSET MATCHES "^${option}_ISSET$")
    SET(${option}_AVAILABLE 1)
    IF(${force1})
    FOREACH(d ${depends1})
      STRING(REGEX REPLACE " +" ";" CMAKE_DEPENDENT_OPTION_DEP "${d}")
      IF(${CMAKE_DEPENDENT_OPTION_DEP})
      ELSE(${CMAKE_DEPENDENT_OPTION_DEP})
          SET(${option}_AVAILABLE 0)
          SET(depends1_AVAILABLE 1)
      ENDIF(${CMAKE_DEPENDENT_OPTION_DEP})
    ENDFOREACH(d)
    ENDIF(${force1})
    IF(${force2})
    FOREACH(d ${depends2})
      STRING(REGEX REPLACE " +" ";" CMAKE_DEPENDENT_OPTION_DEP "${d}")
      IF(${CMAKE_DEPENDENT_OPTION_DEP})
      ELSE(${CMAKE_DEPENDENT_OPTION_DEP})
          SET(${option}_AVAILABLE 0)
          SET(depends2_AVAILABLE 1)
      ENDIF(${CMAKE_DEPENDENT_OPTION_DEP})
    ENDFOREACH(d)
    ENDIF(${force2})
    IF(${option}_AVAILABLE)
      OPTION(${option} "${doc}" "${default}")
      SET(${option} "${${option}}" CACHE BOOL "${doc}" FORCE)
    ELSE(${option}_AVAILABLE)
      IF(${option} MATCHES "^${option}$")
      ELSE(${option} MATCHES "^${option}$")
        SET(${option} "${${option}}" CACHE INTERNAL "${doc}")
      ENDIF(${option} MATCHES "^${option}$")
        IF(depends1_AVAILABLE)
          SET(${option} OFF)
        ELSEIF(depends2_AVAILABLE)
          SET(${option} ON)
        ENDIF(depends1_AVAILABLE)
    ENDIF(${option}_AVAILABLE)
  ELSE(${option}_ISSET MATCHES "^${option}_ISSET$")
    SET(${option} "${${option}_ISSET}")
  ENDIF(${option}_ISSET MATCHES "^${option}_ISSET$")
ENDMACRO(MGL_DEPENDENT_OPTION)
include(CMakeDependentOption)

string(TIMESTAMP MGL_NIGHT "%d.%m.%y")

if(WIN32)
	option(enable-dep-dll "Enable copying off all dependent dll libraries to the install directory" OFF)
endif(WIN32)

option(enable-double "Enable double precision in MathGL library" ON)
option(enable-mpi "Enable mpi")
option(enable-opengl "Enable OpenGL support" ON)
option(enable-all-docs "Enable all documentation building")
#option(enable-doc "Enable documentation building")
option(enable-all "Enable all core features")
option(enable-all-widgets "Enable all Widgets")
option(enable-all-swig "Enable all SWIG based interfaces")
option(enable-rvalue "Enable move constructor support (need C++11)" OFF)
option(enable-pthread "Enable POSIX threads support" OFF)
if(MSVC)
	option(enable-pthr-widget "Enable POSIX threads for widgets" OFF)
else(MSVC)
	option(enable-pthr-widget "Enable POSIX threads for widgets" ON)
endif(MSVC)
option(enable-openmp "Enable OpenMP support" ON)
option(disable-C99complex "Enable C99 complex number support" OFF)

if(enable-pthread AND enable-openmp)
	message(SEND_ERROR "You can't enable POSIX threads and OpenMP at the same time!")
endif(enable-pthread AND enable-openmp)

option(enable-lgpl "Enable only LGPL part of MathGL")
option(enable-mgl2 "Use names 'libmgl2-*' instead of 'libmgl-*'")
option(enable-ltdl "Enable loading modules support")
option(enable-doc-site "Enable HTML documentation for website")
#CMAKE_DEPENDENT_OPTION(enable-doc-site "Enable HTML documentation for website" OFF "NOT enable-all-docs" ON)
CMAKE_DEPENDENT_OPTION(enable-doc-html "Enable HTML documentation" OFF "NOT enable-all-docs" ON)
CMAKE_DEPENDENT_OPTION(enable-doc-info "Enable INFO documentation" OFF "NOT enable-all-docs" ON)
CMAKE_DEPENDENT_OPTION(enable-doc-pdf-ru "Enable Russian PDF documentation" OFF "NOT enable-all-docs" ON)
CMAKE_DEPENDENT_OPTION(enable-doc-pdf-en "Enable English PDF documentation" OFF "NOT enable-all-docs" ON)
#CMAKE_DEPENDENT_OPTION(enable-doc-prc "Enable PDF samples for HTML docs" OFF "NOT enable-all-docs" ON)
#CMAKE_DEPENDENT_OPTION(enable-doc-json "Enable JSON samples for HTML docs" OFF "NOT enable-all-docs" ON)
option(enable-texi2html "Use texi2html (obsolete package) instead of texi2any" OFF)
CMAKE_DEPENDENT_OPTION(enable-mgltex "Enable installation of mgltex package (MGL scripts in LATEX document)" OFF "NOT enable-lgpl" OFF)

CMAKE_DEPENDENT_OPTION(enable-zlib "Enable zlib support" ON "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-png "Enable png support" ON "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-jpeg "Enable jpeg support" OFF "NOT enable-all" ON)
MGL_DEPENDENT_OPTION(enable-gsl "Enable gsl support" OFF "NOT enable-lgpl" ON "NOT enable-all" ON)
MGL_DEPENDENT_OPTION(enable-hdf4 "Enable hdf4 support" OFF "NOT enable-lgpl" ON "NOT enable-all" ON)
MGL_DEPENDENT_OPTION(enable-hdf5 "Enable hdf5 support" OFF "NOT enable-lgpl" ON "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-pdf "Enable pdf support" OFF "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-gif "Enable gif support" OFF "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-arma "Enable Armadillo support" OFF "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-glut "Enable glut support" OFF "NOT enable-all-widgets" ON)
CMAKE_DEPENDENT_OPTION(enable-fltk "Enable fltk widget" OFF "NOT enable-all-widgets" ON)
CMAKE_DEPENDENT_OPTION(enable-wx "Enable wxWidget widget" OFF "NOT enable-all-widgets" ON)
#CMAKE_DEPENDENT_OPTION(enable-qt "Enable Qt4 and/or Qt5 widget(s)" OFF "NOT enable-all-widgets" ON)
CMAKE_DEPENDENT_OPTION(enable-qt "Enable Qt5 widget" OFF "NOT enable-all-widgets" ON)
#option(enable-qt5 "Enable Qt5 widget" OFF)
CMAKE_DEPENDENT_OPTION(enable-qt5asqt "Set Qt5 as default libmgl-qt" OFF "enable-qt5" OFF)
CMAKE_DEPENDENT_OPTION(enable-freetype "Enable freetype support" OFF "NOT enable-all" ON)
set(PY3VERSION_DOTTED "3.9" CACHE STRING "Used python version")
string(REPLACE "." "" PY3VERSION_NODOT ${PY3VERSION_DOTTED})

# msvc fwprintf print char* for the specifier of "%s" format
if(MSVC AND MSVC_VERSION GREATER 1899)
	SET(CMAKE_CXX_FLAGS "/EHsc -D_CRT_STDIO_ISO_WIDE_SPECIFIERS ${CMAKE_CXX_FLAGS}")
	SET(CMAKE_C_FLAGS "-D_CRT_STDIO_ISO_WIDE_SPECIFIERS ${CMAKE_C_FLAGS}")
endif(MSVC AND MSVC_VERSION GREATER 1899)

include(CheckCXXSourceCompiles)

if(${CMAKE_SIZEOF_VOID_P} EQUAL 4)
	set(CMAKE_REQUIRED_FLAGS -msse2 -mfpmath=sse)
	CHECK_CXX_SOURCE_COMPILES("
		int main(void){}" mgl_sse)
	if(mgl_sse)
		SET(CMAKE_CXX_FLAGS "-msse2 -mfpmath=sse ${CMAKE_CXX_FLAGS}")
		SET(CMAKE_C_FLAGS "-msse2 -mfpmath=sse ${CMAKE_C_FLAGS}")
	endif(mgl_sse)
	unset(CMAKE_REQUIRED_FLAGS)
endif(${CMAKE_SIZEOF_VOID_P} EQUAL 4)

#if(enable-qt)
#	if(Qt4_FOUND)
#		set(enable-qt4 ON)
#		find_package(Qt5 COMPONENTS Widgets)
#			set(enable-qt5 ON)
#		endif(Qt5Widgets_FOUND)
#	else(Qt4_FOUND)
#		set(enable-qt5 ON)
#	endif(Qt4_FOUND)
#endif(enable-qt)
if(enable-qt)
	find_package(Qt5 COMPONENTS Widgets)
	set(enable-qt5 ON)
	if(NOT Qt5Widgets_FOUND)
		message(SEND_ERROR "Couldn't find Qt5 widgets.")
	endif(NOT Qt5Widgets_FOUND)
endif(enable-qt)

if(enable-qt4 OR enable-qt5)
	set(QT_ENABLED ON)
	if(enable-qt4asqt AND enable-qt5asqt)
		message(SEND_ERROR "You cannot make Qt4 and Qt5 as qt at the same time.")
	endif(enable-qt4asqt AND enable-qt5asqt)
	if(enable-qt4 AND NOT enable-qt5)
		set(enable-qt4asqt TRUE)
	endif(enable-qt4 AND NOT enable-qt5)
	if(enable-qt5 AND NOT enable-qt4)
		set(enable-qt5asqt TRUE)
	endif(enable-qt5 AND NOT enable-qt4)
# 	if(NOT enable-opengl)
# 		message(SEND_ERROR "You cannot build MathGL with Qt4 or Qt5 without OpenGL enabled.")
# 	endif(NOT enable-opengl)
endif(enable-qt4 OR enable-qt5)

CMAKE_DEPENDENT_OPTION(enable-json-sample "Enable JSON sample (WebKit variant is the default)." ON "QT_ENABLED" OFF)
CMAKE_DEPENDENT_OPTION(enable-json-sample-we "Enable JSON sample (WebEngine variant)." OFF "enable-json-sample" OFF)

=== examples/CMakeLists.txt ===
file(COPY ${CMAKE_SOURCE_DIR}/udav_new.png DESTINATION ${CMAKE_BINARY_DIR}/examples)
file(COPY ${CMAKE_SOURCE_DIR}/examples/iris.dat DESTINATION ${CMAKE_BINARY_DIR}/examples)
file(COPY ${CMAKE_SOURCE_DIR}/examples/Equirectangular-projection.jpg DESTINATION ${CMAKE_BINARY_DIR}/examples)
file(COPY ${CMAKE_SOURCE_DIR}/examples/samples.cpp DESTINATION ${CMAKE_BINARY_DIR}/examples)
file(COPY ${CMAKE_SOURCE_DIR}/examples/wnd_samples.cpp DESTINATION ${CMAKE_BINARY_DIR}/examples)
add_executable(mgl_example wnd_samples.cpp full_test.cpp samples.cpp)
target_link_libraries(mgl_example mgl-static ${getopt_lib-static})
if(CMAKE_BUILD_TYPE STREQUAL "Debug" AND CMAKE_COMPILER_IS_GNUCXX AND enable-lcov)
	setup_target_for_coverage(
	    NAME mgl_coverage
	    EXECUTABLE $<TARGET_FILE:mgl_example> -mgl
	    DEPENDENCIES mgl_example
	)
endif(CMAKE_BUILD_TYPE STREQUAL "Debug" AND CMAKE_COMPILER_IS_GNUCXX AND enable-lcov)

if(MGL_HAVE_FLTK)
	include_directories(${FLTK_INCLUDE_DIR})
	add_executable(mgl_fltk_example wnd_samples.cpp fltk_example.cpp)
	target_link_libraries(mgl_fltk_example mgl-fltk)
endif(MGL_HAVE_FLTK)

if(MGL_HAVE_GLUT)
	add_executable(mgl_glut_example wnd_samples.cpp glut_example.cpp)
	target_link_libraries(mgl_glut_example mgl-glut)
endif(MGL_HAVE_GLUT)

if(MGL_HAVE_WX)
	include(${wxWidgets_USE_FILE})
	add_executable(mgl_wx_example wnd_samples.cpp wx_example.cpp)
	target_link_libraries(mgl_wx_example mgl-wx)
endif(MGL_HAVE_WX)

if(QT_ENABLED)
	add_executable(mgl_qt_example wnd_samples.cpp qt_example.cpp)
	if(enable-qt5)
		include(../scripts/qt5.cmake)
		target_link_libraries(mgl_qt_example mgl-qt5)
	else(enable-qt5)
		include(../scripts/qt4.cmake)
		target_link_libraries(mgl_qt_example mgl-qt4)
	endif(enable-qt5)
	
	if(MGL_HAVE_OPENGL)
		add_executable(mgl_qgl_example wnd_samples.cpp qgl_example.cpp)
		if(enable-qt5)
			target_link_libraries(mgl_qgl_example mgl ${MGL_QT5_LIBS})
		else(enable-qt5)
			target_link_libraries(mgl_qgl_example mgl ${MGL_QT4_LIBS})
		endif(enable-qt5)
	endif(MGL_HAVE_OPENGL)
endif(QT_ENABLED)

if(MGL_HAVE_LTDL)
	add_library(mgl_module MODULE mgl_module.cpp)
	target_link_libraries(mgl_module mgl)	# for compatibility with win32
endif(MGL_HAVE_LTDL)

if(MGL_HAVE_MPI)
	add_executable(mgl_mpi_example mpi_test.cpp)
	target_link_libraries(mgl_mpi_example mgl-mpi mgl ${MPI_LIBRARIES})
	target_include_directories(mgl_mpi_example SYSTEM PUBLIC ${MPI_CXX_INCLUDE_PATH})
endif(MGL_HAVE_MPI)

=== fonts/CMakeLists.txt ===
include_directories( ${MathGL2_SOURCE_DIR}/include ${MathGL2_BINARY_DIR}/include)
set(hdrF ../include/mgl2/font.h ../include/mgl2/define.h ${MathGL2_BINARY_DIR}/include/mgl2/config.h)
add_executable(make_bin make_bin.cpp ../src/font.cpp ${hdrF})
#target_link_libraries(make_bin mgl-static ${getopt_lib-static})
target_link_libraries(make_bin ${MGL_DEP_LIBS})

set(MGL_FONTS STIX adventor  bonum  cursor  heroscn  heros  pagella  schola  termes)
set(MGL_FONTS_BIN )
set(MGL_FONTS_SRC )

foreach(SAMPLE ${MGL_FONTS})
	set(MGL_FONTS_BIN ${MGL_FONTS_BIN} ${MathGL2_BINARY_DIR}/fonts/${SAMPLE}.vfmb)
	add_custom_command(OUTPUT ${MathGL2_BINARY_DIR}/fonts/${SAMPLE}.vfmb
		COMMAND make_bin -p ${MathGL2_SOURCE_DIR}/fonts/ -o ${MathGL2_BINARY_DIR}/fonts/${SAMPLE}.vfmb ${SAMPLE}
		DEPENDS ${SAMPLE}.vfm make_bin )
endforeach(SAMPLE)

add_custom_target(fonts ALL DEPENDS ${MGL_FONTS_BIN})

install(DIRECTORY ${MathGL2_BINARY_DIR}/fonts/ DESTINATION ${MGL_FONT_PATH}
			PATTERN "*[mM]ake*" EXCLUDE
			PATTERN ".svn" EXCLUDE
			PATTERN "*.vfmb")

=== mgllab/CMakeLists.txt ===
# cmake_minimum_required(VERSION 2.8.9)
#
# project( MGLLAB )
#
# include(FindFLTK)
# if(NOT FLTK_FOUND)
# 	message(SEND_ERROR "Couldn't find FLTK library.")
# endif(NOT FLTK_FOUND)
#
# include_directories( ${MGLLAB_SOURCE_DIR} ${MGLLAB_BINARY_DIR})
#
# find_package(MathGL2 REQUIRED FLTK)
# #find_package(MathGL REQUIRED FLTK PATHS /usr/local/lib/CMake/MathGL/)
#
# find_package(OpenMP)
# if(OPENMP_FOUND)
# 	set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
# 	set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
# else(OPENMP_FOUND)
# 	message(SEND_ERROR "Couldn't find OpenMP.")
# endif(OPENMP_FOUND)
#
# include_directories(${FLTK_INCLUDE_DIR})
# set(mgl_lab_src editor.cpp help.cpp mathgl.cpp grid.cpp dialogs.cpp mgllab.cpp option.cpp table.cpp image.cpp)
# set(mgl_lab_hdr mgllab.h image.h)
# add_executable(mgllab ${mgl_lab_src} ${mgl_lab_hdr})
# target_link_libraries(mgllab ${MATHGL2_FLTK_LIBRARY} ${MATHGL2_LIBRARY} ${FLTK_LIBRARIES})
# install(
# 	TARGETS mgllab
# 	RUNTIME DESTINATION bin	)

if(MGL_HAVE_FLTK)
	configure_file(${MathGL2_SOURCE_DIR}/mgllab/mgl.xml.in ${MathGL2_BINARY_DIR}/mgllab/mgl.xml)
	include_directories(${FLTK_INCLUDE_DIR})
	set(mgllab_src editor.cpp help.cpp mathgl.cpp grid.cpp dialogs.cpp mgllab.cpp table.cpp)
	set(mgllab_hdr mgllab.h)
	if(WIN32)
		set(mgllab_src ${mgllab_src} mgllab.rc)
	endif(WIN32)
	add_executable(mgllab ${mgllab_src} ${mgllab_hdr})
	target_link_libraries(mgllab mgl mgl-fltk ${FLTK_LIBRARIES})
	install(
		TARGETS mgllab
		RUNTIME DESTINATION bin	)
	install(FILES udav.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/pixmaps/)
	find_program(findupddb update-desktop-database)
	if(findupddb)
		install(FILES mgllab.desktop DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications/)
		install(CODE "execute_process(COMMAND \"${findupddb}\" \"${CMAKE_INSTALL_PREFIX}/share/applications\")")
	endif(findupddb)
	find_program(findupmdb update-mime-database)
	if(findupmdb)
		install(FILES ${CMAKE_BINARY_DIR}/mgllab/mgl.xml DESTINATION ${CMAKE_INSTALL_PREFIX}/share/mime/packages/)
		install(CODE "execute_process(COMMAND \"${findupmdb}\" \"${CMAKE_INSTALL_PREFIX}/share/mime\")")
	endif(findupmdb)

	mgl_po_src(${mgllab_src} ${mgllab_hdr})

endif(MGL_HAVE_FLTK)

=== texinfo/CMakeLists.txt ===
configure_file(${MathGL2_SOURCE_DIR}/texinfo/version.texi.in ${MathGL2_BINARY_DIR}/texinfo/version.texi)

#set(MGL_EXTRA light pendelta)
set(MGL_EXTRA )
set(MGL_PNG_ONLY quality0 quality1 quality2 quality4 quality5 quality6 quality8 pendelta fexport) 
set(MGL_PNG 3wave alpha apde area aspect axial axis background barh bars belt beltc bifurcation box boxplot boxs candle chart cloud colorbar combined cones cont cont3 cont_xyz contd contf contf3 contf_xyz conts contv correl curvcoor cut daisy dat_diff dat_extra data1 data2 dcont dens dens3 dens_xyz detect dew diffract dilate dots earth error error2 export fall fit flame2d flow flow3 fog fonts grad hist icon ifs2d ifs3d indirect inplot iris keep label lamerey legend light lines loglog map mark mask mesh minmax mirror molecule ode ohlc param1 param2 param3 paramv parser pde pipe plot pmap primitives projection projection5 pulse qo2d radar refill region scanfile schemes section several_light solve stem step stereo stfa style surf surf3 surf3a surf3c surf3ca surfa surfc surfca table tape tens ternary text text2 textmark ticks tile tiles torus traj triangulation triplot tube type0 type1 type2 vect vect3 venn )
set(MGL_PNG_N )
set(MGL_PNG_S )
set(MGL_PNG_J )
set(MGL_PNG_D )

set(MGL_OUT ${CMAKE_BINARY_DIR}/texinfo)
set(MGL_TEX ${CMAKE_SOURCE_DIR}/texinfo)
file(MAKE_DIRECTORY ${MGL_OUT}/udav)
file(MAKE_DIRECTORY ${MGL_OUT}/png)
file(MAKE_DIRECTORY ${MGL_OUT}/small)
file(MAKE_DIRECTORY ${MGL_OUT}/json)
file(MAKE_DIRECTORY ${MGL_OUT}/pdf)
file(COPY ${MGL_TEX}/qt.png ${MGL_TEX}/fltk.png ${MGL_TEX}/classes.png ${MGL_TEX}/emblem_sm.png ${MGL_TEX}/datadvance.png DESTINATION ${MGL_OUT})
file(COPY ${MGL_TEX}/index.html ${MGL_TEX}/json.html ${MGL_TEX}/mathgl.js DESTINATION ${MGL_OUT})
file(COPY ${CMAKE_SOURCE_DIR}/examples/iris.dat DESTINATION ${MGL_OUT}/png)
file(COPY ${CMAKE_SOURCE_DIR}/examples/iris.dat DESTINATION ${MGL_OUT}/small)
file(COPY ${CMAKE_SOURCE_DIR}/examples/iris.dat DESTINATION ${MGL_OUT}/json)
file(COPY ${CMAKE_SOURCE_DIR}/examples/iris.dat DESTINATION ${MGL_OUT}/pdf)
file(COPY ${CMAKE_SOURCE_DIR}/udav_new.png DESTINATION ${MGL_OUT}/png)
file(COPY ${CMAKE_SOURCE_DIR}/udav_new.png DESTINATION ${MGL_OUT}/small)
file(COPY ${CMAKE_SOURCE_DIR}/udav_new.png DESTINATION ${MGL_OUT}/json)
file(COPY ${CMAKE_SOURCE_DIR}/udav_new.png DESTINATION ${MGL_OUT}/pdf)
file(COPY ${CMAKE_SOURCE_DIR}/examples/Equirectangular-projection.jpg DESTINATION ${MGL_OUT}/png)
file(COPY ${CMAKE_SOURCE_DIR}/examples/Equirectangular-projection.jpg DESTINATION ${MGL_OUT}/small)
file(COPY ${CMAKE_SOURCE_DIR}/examples/Equirectangular-projection.jpg DESTINATION ${MGL_OUT}/json)
file(COPY ${CMAKE_SOURCE_DIR}/examples/Equirectangular-projection.jpg DESTINATION ${MGL_OUT}/pdf)
file(COPY ${CMAKE_SOURCE_DIR}/examples/samples.cpp DESTINATION ${MGL_OUT})
file(COPY ${CMAKE_SOURCE_DIR}/examples/wnd_samples.cpp DESTINATION ${MGL_OUT})

set(UDAV_IMG udav_arg.png udav_calc.png udav_cmd.png udav_data.png udav_mask.png
	udav_gen_set.png udav_help.png udav_light.png udav_main.png udav_opt.png udav_inplot.png
	udav_pen.png udav_prop.png udav_sch.png udav_txt.png udav_var.png)
foreach(SAMPLE ${UDAV_IMG})
	file(COPY ${MGL_TEX}/udav/${SAMPLE} DESTINATION ${MGL_OUT}/udav/)
endforeach(SAMPLE)

add_custom_command(OUTPUT ${MGL_OUT}/samples.texi
	COMMAND mgl_example -texi
	DEPENDS mgl_example
	WORKING_DIRECTORY ${MGL_OUT} )
#add_custom_command(OUTPUT ${MGL_OUT}/time.texi
#	COMMAND mgl_example -time
#	DEPENDS mgl_example
#	WORKING_DIRECTORY ${MGL_OUT} )
#add_custom_command(OUTPUT ${MGL_OUT}/time_big.texi
#	COMMAND mgl_example -time -big
#	DEPENDS mgl_example
#	WORKING_DIRECTORY ${MGL_OUT} )


foreach(SAMPLE ${MGL_PNG_ONLY})
	set(MGL_PNG_N ${MGL_PNG_N} ${MGL_OUT}/png/${SAMPLE}.png)
	add_custom_command(OUTPUT ${MGL_OUT}/png/${SAMPLE}.png
		COMMAND mgl_example -kind=${SAMPLE}
		DEPENDS mgl_example
		WORKING_DIRECTORY ${MGL_OUT}/png )
	set(MGL_PNG_S ${MGL_PNG_S} ${MGL_OUT}/small/${SAMPLE}-sm.png)
	add_custom_command(OUTPUT ${MGL_OUT}/small/${SAMPLE}-sm.png
		COMMAND mgl_example -kind=${SAMPLE} -mini
		DEPENDS mgl_example
		WORKING_DIRECTORY ${MGL_OUT}/small )
endforeach(SAMPLE)

foreach(SAMPLE ${MGL_PNG})
	set(MGL_PNG_N ${MGL_PNG_N} ${MGL_OUT}/png/${SAMPLE}.png)
	add_custom_command(OUTPUT ${MGL_OUT}/png/${SAMPLE}.png
		COMMAND mgl_example -kind=${SAMPLE}
		DEPENDS mgl_example
		WORKING_DIRECTORY ${MGL_OUT}/png )
	set(MGL_PNG_S ${MGL_PNG_S} ${MGL_OUT}/small/${SAMPLE}-sm.png)
	add_custom_command(OUTPUT ${MGL_OUT}/small/${SAMPLE}-sm.png
		COMMAND mgl_example -kind=${SAMPLE} -mini
		DEPENDS mgl_example
		WORKING_DIRECTORY ${MGL_OUT}/small )

	if(MGL_HAVE_DOC_JSON)
		set(MGL_PNG_J ${MGL_PNG_J} ${MGL_OUT}/json/${SAMPLE}.json)
		add_custom_command(OUTPUT ${MGL_OUT}/json/${SAMPLE}.json
			COMMAND mgl_example -json -kind=${SAMPLE}
			DEPENDS mgl_example
			WORKING_DIRECTORY ${MGL_OUT}/json )
	endif(MGL_HAVE_DOC_JSON)
	if(MGL_HAVE_DOC_PRC)
		set(MGL_PNG_D ${MGL_PNG_D} ${MGL_OUT}/pdf/${SAMPLE}.pdf)
		add_custom_command(OUTPUT ${MGL_OUT}/pdf/${SAMPLE}.pdf
			COMMAND mgl_example -pdf -kind=${SAMPLE}
			DEPENDS mgl_example
			WORKING_DIRECTORY ${MGL_OUT}/pdf )
	endif(MGL_HAVE_DOC_PRC)
endforeach(SAMPLE)

foreach(SAMPLE ${MGL_EXTRA})
	set(MGL_PNG_N ${MGL_PNG_N} ${MGL_OUT}/png/${SAMPLE}.png)
	add_custom_command(OUTPUT ${MGL_OUT}/png/${SAMPLE}.png
		COMMAND mgl_example -kind=${SAMPLE}
		DEPENDS mgl_example
		WORKING_DIRECTORY ${MGL_OUT}/png )
	set(MGL_PNG_S ${MGL_PNG_S} ${MGL_OUT}/small/${SAMPLE}-sm.png)
	add_custom_command(OUTPUT ${MGL_OUT}/small/${SAMPLE}-sm.png
		COMMAND mgl_example -kind=${SAMPLE} -mini
		DEPENDS mgl_example
		WORKING_DIRECTORY ${MGL_OUT}/small )
endforeach(SAMPLE)

# NOTE: direct generation of time*.texi is too slow :(
set(list_texi_files_en overview_en.texi example_en.texi ex_mgl_en.texi parse_en.texi formats_en.texi udav_en.texi symbols_en.texi core_en.texi concept_en.texi widget_en.texi data_en.texi other_en.texi appendix_en.texi fdl.texi ${MathGL2_BINARY_DIR}/texinfo/version.texi time.texi time_big.texi ${MGL_OUT}/samples.texi )
set(list_texi_files_ru overview_ru.texi example_ru.texi ex_mgl_ru.texi parse_ru.texi formats_ru.texi udav_ru.texi symbols_ru.texi core_ru.texi concept_ru.texi widget_ru.texi data_ru.texi other_ru.texi appendix_ru.texi fdl.texi ${MathGL2_BINARY_DIR}/texinfo/version.texi time.texi time_big.texi ${MGL_OUT}/samples.texi )

add_custom_command(OUTPUT ${MGL_OUT}/mathgl_en.info
	COMMAND ${findmi} ${MGL_TEX}/mathgl_en.texi
	DEPENDS ${list_texi_files_en} mathgl_en.texi #${MGL_PNG_N}
	WORKING_DIRECTORY ${MGL_OUT}
)
add_custom_command(OUTPUT ${MGL_OUT}/mathgl_ru.info
	COMMAND ${findmi} ${MGL_TEX}/mathgl_ru.texi
	DEPENDS ${list_texi_files_ru} mathgl_ru.texi #${MGL_PNG_N}
	WORKING_DIRECTORY ${MGL_OUT}
)

add_custom_command(OUTPUT ${MGL_OUT}/mathgl_en.html
	COMMAND ${findth} ${th_opt} -I ${MGL_OUT} --no-split ${MGL_TEX}/mathgl_en.texi
	DEPENDS ${list_texi_files_en} mathgl_en.texi ${MGL_PNG_N}
	WORKING_DIRECTORY ${MGL_OUT}
)
add_custom_command(OUTPUT ${MGL_OUT}/mgl_en.html
	COMMAND ${findth} ${th_opt} --set-customization-variable 'BODYTEXT ' -I ${MGL_OUT} --no-split ${MGL_TEX}/mgl_en.texi
	# following line bypass FLTK bugs
	COMMAND sed "'s/&ndash;/-/g'" -i ${MGL_OUT}/mgl_en.html
	COMMAND sed "'s/&lsquo;/`/g'" -i ${MGL_OUT}/mgl_en.html
	COMMAND sed "'s/&rsquo;/`/g'" -i ${MGL_OUT}/mgl_en.html
	DEPENDS ${list_texi_files_en} mgl_en.texi ${MGL_PNG_N}
	WORKING_DIRECTORY ${MGL_OUT}
)
add_custom_command(OUTPUT ${MGL_OUT}/mathgl_ru.html
	COMMAND ${findth} ${th_opt} -I=${MGL_OUT} --no-split ${MGL_TEX}/mathgl_ru.texi
	DEPENDS ${list_texi_files_ru} mathgl_ru.texi ${MGL_PNG_N}
	WORKING_DIRECTORY ${MGL_OUT}
)
add_custom_command(OUTPUT ${MGL_OUT}/mgl_ru.html
	COMMAND ${findth} ${th_opt} --set-customization-variable 'BODYTEXT ' -I=${MGL_OUT} --no-split ${MGL_TEX}/mgl_ru.texi
	# following line bypass FLTK bugs
	COMMAND sed "'s/&ndash;/-/g'" -i ${MGL_OUT}/mgl_ru.html
	COMMAND sed "'s/&lsquo;/`/g'" -i ${MGL_OUT}/mgl_ru.html
	COMMAND sed "'s/&rsquo;/`/g'" -i ${MGL_OUT}/mgl_ru.html
	DEPENDS ${list_texi_files_ru} mgl_ru.texi ${MGL_PNG_N}
	WORKING_DIRECTORY ${MGL_OUT}
)

add_custom_command(OUTPUT ${site_en}
	COMMAND ${findth} ${th_opt} -I=${MGL_OUT}/png --split=node -o doc_en ${MGL_TEX}/doc_en.texi
	DEPENDS ${list_texi_files_en} doc_en.texi ${MGL_PNG_N} web_en.texi ${MGL_PNG_S} ${MGL_PNG_J} ${MGL_PNG_D}
	WORKING_DIRECTORY ${MGL_OUT}
)
add_custom_command(OUTPUT ${site_ru}
	COMMAND ${findth} ${th_opt} -I=${MGL_OUT}/png --split=node -o doc_ru ${MGL_TEX}/doc_ru.texi
	DEPENDS ${list_texi_files_ru} doc_ru.texi ${MGL_PNG_N} web_ru.texi ${MGL_PNG_S} ${MGL_PNG_J} ${MGL_PNG_D}
	WORKING_DIRECTORY ${MGL_OUT}
)

add_custom_command(OUTPUT ${MGL_OUT}/mathgl_en.pdf
	COMMAND ${findtp} ${MGL_TEX}/mathgl_en.texi
	COMMAND ${findtp} ${MGL_TEX}/mathgl_en.texi
	COMMAND ${findtp} ${MGL_TEX}/mathgl_en.texi
	DEPENDS ${list_texi_files_en} mathgl_en.texi ${MGL_PNG_N}
	WORKING_DIRECTORY ${MGL_OUT}
)
add_custom_command(OUTPUT ${MGL_OUT}/mgl_en.pdf
	COMMAND ${findtp} ${MGL_TEX}/mgl_en.texi
	COMMAND ${findtp} ${MGL_TEX}/mgl_en.texi
	COMMAND ${findtp} ${MGL_TEX}/mgl_en.texi
	DEPENDS ${list_texi_files_en} mgl_en.texi ${MGL_PNG_N}
	WORKING_DIRECTORY ${MGL_OUT}
)

add_custom_command(OUTPUT ${MGL_OUT}/mathgl_ru.pdf
	COMMAND ${findtp} ${MGL_TEX}/mathgl_ru.texi
	COMMAND ${findtp} ${MGL_TEX}/mathgl_ru.texi
	COMMAND ${findtp} ${MGL_TEX}/mathgl_ru.texi
	DEPENDS ${list_texi_files_ru} mathgl_ru.texi ${MGL_PNG_N}
	WORKING_DIRECTORY ${MGL_OUT}
)
add_custom_command(OUTPUT ${MGL_OUT}/mgl_ru.pdf
	COMMAND ${findtp} ${MGL_TEX}/mgl_ru.texi
	COMMAND ${findtp} ${MGL_TEX}/mgl_ru.texi
	COMMAND ${findtp} ${MGL_TEX}/mgl_ru.texi
	DEPENDS ${list_texi_files_en} mgl_ru.texi ${MGL_PNG_N}
	WORKING_DIRECTORY ${MGL_OUT}
)

if(MGL_HAVE_DOC_INFO)
	add_custom_target(doc_info ALL
		DEPENDS ${MGL_OUT}/mathgl_en.info
		DEPENDS ${MGL_OUT}/mathgl_ru.info
	)
# TODO: try to install all mathgl*.info* in future!!!
	install(FILES ${MGL_OUT}/mathgl_en.info ${MGL_OUT}/mathgl_en.info-1 ${MGL_OUT}/mathgl_en.info-2 ${MGL_OUT}/mathgl_en.info-3 DESTINATION ${MGL_INFO_PATH})
endif(MGL_HAVE_DOC_INFO)

if(MGL_HAVE_DOC_HTML)
	add_custom_target(doc_html ALL
	DEPENDS ${MGL_OUT}/mgl_en.html
	DEPENDS ${MGL_OUT}/mathgl_en.html
	DEPENDS ${MGL_OUT}/mgl_ru.html
	DEPENDS ${MGL_OUT}/mathgl_ru.html
	)
	install(FILES ${MGL_TEX}/qt.png ${MGL_TEX}/fltk.png ${MGL_TEX}/classes.png ${MGL_TEX}/datadvance.png DESTINATION ${MGL_DOC_PATH})
	install(FILES ${MGL_OUT}/mathgl_en.html ${MGL_OUT}/mgl_en.html ${MGL_OUT}/mathgl_ru.html ${MGL_OUT}/mgl_ru.html DESTINATION ${MGL_DOC_PATH})
	install(DIRECTORY ${MGL_OUT}/png DESTINATION ${MGL_DOC_PATH})
	install(DIRECTORY ${MGL_OUT}/udav DESTINATION ${MGL_DOC_PATH})
endif(MGL_HAVE_DOC_HTML)

if(MGL_HAVE_DOC_SITE)
	add_custom_target(doc_site ALL
	DEPENDS ${site_en}
	DEPENDS ${site_ru}
	)
endif(MGL_HAVE_DOC_SITE)

if(MGL_HAVE_DOC_PDF_EN)
	add_custom_target(doc_en ALL
		DEPENDS ${MGL_OUT}/mgl_en.pdf
		DEPENDS ${MGL_OUT}/mathgl_en.pdf
	)
	install(FILES ${MGL_OUT}/mathgl_en.pdf ${MGL_OUT}/mgl_en.pdf DESTINATION ${MGL_DOC_PATH})
endif(MGL_HAVE_DOC_PDF_EN)

if(MGL_HAVE_DOC_PDF_RU)
	add_custom_target(doc_ru ALL
#			DEPENDS ${MGL_OUT}/mgl_ru.pdf
#			DEPENDS ${MGL_OUT}/mathgl_ru.pdf
	)
#		install(FILES ${MGL_OUT}/mathgl_ru.pdf DESTINATION ${MGL_DOC_PATH})
endif(MGL_HAVE_DOC_PDF_RU)

set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "doc_en;doc_ru;./mathgl*.*;./mgl*.*")

install(FILES ${MGL_TEX}/mglconv.1 ${MGL_TEX}/mglview.1 ${MGL_TEX}/udav.1 ${MGL_TEX}/mgl.cgi.1 DESTINATION ${MGL_MAN_PATH}/man1)
install(FILES ${MGL_TEX}/mgl.5 DESTINATION ${MGL_MAN_PATH}/man5)

=== widgets/CMakeLists.txt ===
include(GenerateExportHeader)

if(MSVC)
	add_definitions(-DMGL_LIB_MSVC -DMGL_WIDGETS_DLL)
endif(MSVC)

if(MGL_HAVE_FLTK)
	mgl_add_lib(fltk fltk.cpp  image.cpp  image.h ../include/mgl2/fltk.h ../include/mgl2/Fl_MathGL.h)
	target_include_directories(mgl-fltk SYSTEM PUBLIC ${FLTK_INCLUDE_DIR})
	target_include_directories(mgl-fltk-static SYSTEM PUBLIC ${FLTK_INCLUDE_DIR})
	target_link_libraries(mgl-fltk mgl ${FLTK_LIBRARIES})
	target_link_libraries(mgl-fltk-static mgl-static ${FLTK_LIBRARIES})
endif(MGL_HAVE_FLTK)

if(MGL_HAVE_GLUT)
	mgl_add_lib(glut glut.cpp ../include/mgl2/glut.h)
	target_include_directories(mgl-glut SYSTEM PUBLIC ${GLUT_INCLUDE_DIR})
	target_include_directories(mgl-glut-static SYSTEM PUBLIC ${GLUT_INCLUDE_DIR})
	target_link_libraries(mgl-glut mgl ${GLUT_LIBRARIES} ${OPENGL_LIBRARIES})
	target_link_libraries(mgl-glut-static mgl-static ${GLUT_LIBRARIES} ${OPENGL_LIBRARIES})
endif(MGL_HAVE_GLUT)

if(MGL_HAVE_WX)
	mgl_add_lib(wx wx.cpp ../include/mgl2/wx.h)
	include(${wxWidgets_USE_FILE})
	target_link_libraries(mgl-wx mgl ${wxWidgets_LIBRARIES})
	target_link_libraries(mgl-wx-static mgl-static ${wxWidgets_LIBRARIES})
endif(MGL_HAVE_WX)

#add_subdirectory( qt4 )
add_subdirectory( qt5 )

mgl_po_src(fltk.cpp ../include/mgl2/fltk.h ../include/mgl2/Fl_MathGL.h glut.cpp ../include/mgl2/glut.h wx.cpp ../include/mgl2/wx.h qt.cpp ../include/mgl2/qt.h  ../include/mgl2/qmathgl.h)

=== widgets/qt4/CMakeLists.txt ===
include(GenerateExportHeader)

if(enable-qt4)
	include(../../scripts/qt4.cmake)
	set(MGL_QT4_FILES ../qt.cpp ../../include/mgl2/qt.h ../../include/mgl2/qmathgl.h)
	mgl_add_lib(qt4 ${MGL_QT4_FILES})
	target_link_libraries(mgl-qt4 mgl ${MGL_QT4_LIBS})
	target_link_libraries(mgl-qt4-static mgl-static ${MGL_QT4_LIBS})
	if(enable-qt4asqt)
		mgl_add_lib(qt ${MGL_QT4_FILES})
		target_link_libraries(mgl-qt mgl ${MGL_QT4_LIBS})
		target_link_libraries(mgl-qt-static mgl-static ${MGL_QT4_LIBS})
	endif(enable-qt4asqt)

	if(MGL_HAVE_FLTK AND NOT enable-qt5)
		mgl_add_lib(wnd ${MGL_QT4_FILES} ../fltk.cpp ../../include/mgl2/fltk.h ../image.cpp ../image.h)
		target_include_directories(mgl-wnd SYSTEM PUBLIC ${FLTK_INCLUDE_DIR})
		target_include_directories(mgl-wnd-static SYSTEM PUBLIC ${FLTK_INCLUDE_DIR})
		target_link_libraries(mgl-wnd mgl ${FLTK_LIBRARIES} ${MGL_QT4_LIBS})
		target_link_libraries(mgl-wnd-static mgl-static ${FLTK_LIBRARIES} ${MGL_QT4_LIBS})
	endif(MGL_HAVE_FLTK AND  NOT enable-qt5)
endif(enable-qt4)

=== debian/changelog ===
mathgl (8.0.1-7.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 02:33:14 +0000

mathgl (8.0.1-7.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062853

 -- Graham Inggs <ginggs@debian.org>  Thu, 29 Feb 2024 12:12:57 +0000

mathgl (8.0.1-7) unstable; urgency=medium

  * Team upload.
  * Create /usr/lib/python3/dist-packages/mathgl/__init__.py only for
    arch-dependant builds to enable arch-indep builds
  * Fix build on i386

 -- Andreas Tille <tille@debian.org>  Thu, 15 Feb 2024 07:53:06 +0100

mathgl (8.0.1-6) unstable; urgency=medium

  * Team upload.
  * Run autopkgtest with all supported Python3 versions
  * Make sure autopkgtest also passes with Python3.12
    Closes: #1061810
  * d/rules: 'Joey Hess and Craig Small' boilerplate removed since this
    is just no example.
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Fix day-of-week for changelog entry 1.10.2.1-2. (lintian-brush)
  * Rely on pre-initialized dpkg-architecture variables. (lintian-brush)
  * Use secure URI in Homepage field. (lintian-brush)

 -- Andreas Tille <tille@debian.org>  Wed, 14 Feb 2024 21:12:33 +0100

mathgl (8.0.1-5) unstable; urgency=medium

  * d/control:
    + Don't use qtwebengine5-dev on mipsel, package to be removed.
      Thanks to Bas Couwenberg for the patch (Closes: #1041920)
    + Do not (build-)depend on the deprecated packages
      libfontconfig1-dev et libgl1-mesa-dev
    + Bump Standards-Version to 4.6.2 (no changes needed)
  * Add build-time check and autopkgtest support (Closes: #1035174)
  * d/rules: Add __init__.py file to the mathgl Python module

 -- Rafael Laboissière <rafael@debian.org>  Sun, 07 Jan 2024 16:41:30 -0300

mathgl (8.0.1-4) unstable; urgency=medium

  * Team upload.
  * Transition to wxWidgets 3.2 (Closes: #1019763)

 -- Scott Talbert <swt@techie.net>  Tue, 18 Oct 2022 22:40:24 -0400

mathgl (8.0.1-3) unstable; urgency=medium

  * Make CMake "find_package(MathGL2)" work
    + d/control: libmgl-dev depend on mathgl (for /usr/bin/mgltask) and
      udav (for /usr/bin/udav)
    + d/mathgl.install: Install mgl.cgi in /usr/lib/cgi-bin
    + d/mathgl.links: Symlink /usr/lib/cgi-bin/mgl.cgi in /usr/bin
      (avoid Lintian warning spare-manual-page)
    Thanks to Marius Mikucionis for the diagnosis (Closes: #1004218)
  * d/control: Make libmgl-dev depend on lib{gif,hdf4,hdf5,hpdf}-dev
    Thanks to Marius Mikucionis for the diagnosis (Closes: #1004219)
  * d/s/lintian-overrides: New file (override warnings source-is-missing)

 -- Rafael Laboissière <rafael@debian.org>  Tue, 30 Aug 2022 18:50:47 -0300

mathgl (8.0.1-2) unstable; urgency=medium

  [ Rafael Laboissière ]
  * d/control: Bump Standards-Version to 4.6.1 (no changes needed)

  [ Vagrant Cascadian ]
  * d/rules: Pass -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON via dh_auto_configure
    override (Closes: #1003915)

 -- Rafael Laboissière <rafael@debian.org>  Mon, 30 May 2022 07:04:37 -0300

mathgl (8.0.1-1) unstable; urgency=medium

  * New upstream version 8.0.1
  * d/p/libs-version-soversion.patch: Drop patch (applied upstream)
  * d/p/spelling-errors.patch: Refresh for new upstream version

 -- Rafael Laboissière <rafael@debian.org>  Thu, 13 Jan 2022 07:03:16 -0300

mathgl (8.0-1~exp) experimental; urgency=medium

  * Upload to experimental, due to the bump in the SOVERSION of the
    libraries and the name of the packages.

  * New upstream version 8.0
  * Adjust package names for new upstream release
  * Drop Replaces and Conflicts relationships for the library packages
  * d/control: Add myself to the list of Uploaders
  * d/p/spelling-errors.patch: New patch
  * d/p/libs-version-soversion.patch: New patch
  * d/copyright: Add stanza for debian/* files

 -- Rafael Laboissière <rafael@debian.org>  Sat, 08 Jan 2022 13:32:50 -0300

=== debian/control ===
Source: mathgl
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>,
  Alastair McKinstry <mckinstry@debian.org>,
  Rafael Laboissière <rafael@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5),
 chrpath,
 cmake,
 debhelper-compat (= 13),
 desktop-file-utils,
 dh-sequence-python3,
 file,
 fluid,
 freeglut3-dev,
 libfltk1.3-dev,
 libfontconfig-dev,
 libgif-dev,
 libgl-dev,
 libgsl-dev,
 libhdf4-dev,
 libhdf5-dev,
 libhpdf-dev,
 libjpeg-dev,
 libltdl-dev,
 liblua5.1-dev,
 libpng-dev,
 libqt5opengl5-dev,
 libqt5webkit5-dev,
 libtiff-dev,
 libwxgtk3.2-dev,
 libxcursor-dev,
 libxft-dev,
 libxi-dev,
 libxinerama-dev,
 libxmu-dev,
 mpi-default-dev,
 python3-dev,
 python3-numpy,
 qtwebengine5-dev [amd64 arm64 armhf i386],
 swig,
 texinfo,
 texlive,
 texlive-plain-generic
Standards-Version: 4.6.2
Homepage: https://mathgl.sourceforge.net/doc_en/Main.html
Vcs-Git: https://salsa.debian.org/science-team/mathgl.git
Vcs-Browser: https://salsa.debian.org/science-team/mathgl
Rules-Requires-Root: no

Package: mathgl
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl8t64 (= ${binary:Version})
Description: library for scientific graphs (utilities and examples)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains MathGL utilities and examples.

Package: udav
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl8t64 (= ${binary:Version})
Description: library for scientific graphs (window interface)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the udav window environment based on mathgl.

# Package: mathgl-doc-en
# Architecture: all
# Section: doc
# Depends: dpkg (>= 1.15.4) | install-info, ${misc:Depends}
# Replaces: mathgl-doc, mathgl-doc-ru
# Conflicts: mathgl-doc, mathgl-doc-ru
# Description: library for scientific graphs (English documentation)
#  A free cross-platform library of fast C++ routines for plotting data in up
#  to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
#  files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
#  MathGL can also be used in the console. There are interfaces to a set of
#  languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
#  .
#  This package contains the MathGL documentation in English.

Package: libmgl8t64
Provides: ${t64:Provides}
Replaces: libmgl8
Breaks: libmgl8 (<< ${source:Version})
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl-data (= ${source:Version})
Description: library for scientific graphs (main runtime library)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the shared object files.

Package: libmgl-mpi8t64
Provides: ${t64:Provides}
Replaces: libmgl-mpi8
Breaks: libmgl-mpi8 (<< ${source:Version})
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl-data (= ${source:Version})
Description: library for scientific graphs (mpi enhanced runtime library)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the, parallel interface enhanced, shared object
 files.

Package: libmgl-wnd8t64
Provides: ${t64:Provides}
Replaces: libmgl-wnd8
Breaks: libmgl-wnd8 (<< ${source:Version})
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for scientific graphs (windows runtime library)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the window opening related shared object files based
 on Fltk, Qt and Wx.

Package: libmgl-glut8t64
Provides: ${t64:Provides}
Replaces: libmgl-glut8
Breaks: libmgl-glut8 (<< ${source:Version})
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for scientific graphs (glut interface for windows)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the glut interface shared object files for window
 opening.

Package: libmgl-qt5-8t64
Provides: ${t64:Provides}
Replaces: libmgl-qt5-8
Breaks: libmgl-qt5-8 (<< ${source:Version})
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for scientific graphs (Qt interface for windows)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the Qt interface shared object files for window
 opening.

Package: libmgl-fltk8t64
Provides: ${t64:Provides}
Replaces: libmgl-fltk8
Breaks: libmgl-fltk8 (<< ${source:Version})
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for scientific graphs (fltk interface for windows)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the fltk interface shared object files for window
 opening.

Package: libmgl-wx8t64
Provides: ${t64:Provides}
Replaces: libmgl-wx8
Breaks: libmgl-wx8 (<< ${source:Version})
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for scientific graphs (wx interface for windows)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the wx interface shared object files for window
 opening.

# Package: mgl-lua
# Architecture: any
# Section: libs
# Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl-data
# Description: library for scientific graphs (Lua interface)
#  A free cross-platform library of fast C++ routines for plotting data in up
#  to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
#  files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
#  MathGL can also be used in the console. There are interfaces to a set of
#  languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
#  .
#  This package contains the Lua interface shared object files.

Package: libmgl-data
Architecture: all
Multi-Arch: foreign
Section: misc
Depends: ${misc:Depends}
Description: library for scientific graphs (data files)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the MathGL data files.

Package: libmgl-dev
Architecture: any
Section: libdevel
Depends: libgif-dev,
         libgsl-dev,
         libgl-dev,
         libhdf4-dev,
         libhdf5-dev,
         libhpdf-dev,
         libmgl8t64 (= ${binary:Version}),
         libmgl-fltk8t64 (= ${binary:Version}),
         libmgl-glut8t64 (= ${binary:Version}),
         libmgl-mpi8t64 (= ${binary:Version}),
         libmgl-qt5-8t64 (= ${binary:Version}),
         libmgl-wnd8t64 (= ${binary:Version}),
         libmgl-wx8t64 (= ${binary:Version}),
         libpng-dev,
         mathgl,
         udav,
         ${misc:Depends}
Description: library for scientific graphs (development files)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the development files.

Package: python3-mathgl
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3,
 python3-numpy
Description: library for scientific graphs (Python module)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package provides the Python v.3 module for mathgl.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v

CXXFLAGS:= $(filter-out -Werror=format-security, $(shell dpkg-buildflags --get CXXFLAGS))

include /usr/share/dpkg/architecture.mk

ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel))
	export DEB_CXXFLAGS_MAINT_APPEND = -g0
endif

DOTTED:=`py3versions -d  |  sed 's/python//' `
NODOT:=`py3versions -d | sed 's/\.//' | sed 's/python//' `

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --			\
                -DPY3VERSION_DOTTED=$(DOTTED)	\
                -DPY3VERSION_NODOT=$(NODOT)	\
                -Denable-mpi=ON			\
                -Denable-ltdl=ON		\
                -Denable-jpeg=ON		\
                -Denable-gsl=ON			\
                -Denable-hdf4=ON		\
                -Denable-hdf5=ON		\
                -Denable-pdf=ON			\
                -Denable-gif=ON			\
                -Denable-glut=ON		\
                -Denable-fltk=ON		\
                -Denable-wx=ON			\
                -Denable-qt5=ON			\
                -Denable-qt5asqt=ON		\
                -Denable-json-sample=ON		\
                -Denable-json-sample-we=ON	\
                -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
                -Denable-python=ON

override_dh_python3:
	dh_numpy3

ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel alpha))
override_dh_dwz:
	@echo bypass dwz that causes build failures
endif

override_dh_auto_test:
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	LOCAL=true debian/tests/run-tests
endif

execute_after_dh_installdeb-arch:
	echo "from .mathgl import *" > debian/python3-mathgl/usr/lib/python3/dist-packages/mathgl/__init__.py

=== debian/tests/control ===
Test-Command: debian/tests/run-tests
Depends: @, @builddeps@, python3-all
